/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/
#ifndef RESAMPLE_H
#define RESAMPLE_H

#if (MFCD_REDUCED_RES)

typedef struct   Resize_Parameters
{
  int input_width;
  int input_height;
  int output_width;
  int output_heigh;
  int crop_x0 ;
  int crop_y0 ;
  int crop_w ;
  int crop_h ;  
  int input_chroma_phase_shift_x ;
  int input_chroma_phase_shift_y ;
  int output_chroma_phase_shift_x ;
  int output_chroma_phase_shift_y ;

  int input_stride[3];  //input_stride Y U V
  int output_stride[3]; //output_stride Y U V

  int minValue;
  int maxValue;

  int down_sample;//1:downsampling ,0:upsampling

  imgpel* img_buffer[3];

  int img_stride;

  int* resize_buffer;
  int* resize_buffer_tmp;

  //!<0:Y 1:UV
  int* pos_x[2];
  int* pos_y[2];

  int NormalizeResolutionDepth;
}ResizeParameters;


extern int init_ImageResize(ResizeParameters* ResizeParams, 
                int input_width, int intput_height, int output_width, int output_heigh );

extern void destroy_ImageResize(ResizeParameters* pResizeParams);



extern void generic_upsampler(ResizeParameters* ResizeParams,
               imgpel**low_imgY,imgpel**low_imgU,imgpel**low_imgV,
               imgpel**high_imgY,imgpel**high_imgU,imgpel**high_imgV,int component,int method);
#endif

#endif
