/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/
/*!
 **************************************************************************
 *  \file dec_statistics.h
 *
 *  \brief
 *     Various decoding statistics
 *
 *  \author
 *      Main contributors (see contributors.h for copyright, address and affiliation details)
 *      - Alexis Tourapis                 <alexismt@ieee.org>
 *
 **************************************************************************
 */

#ifndef _DEC_STATISTICS_H_
#define _DEC_STATISTICS_H_
#include "global.h"

typedef struct dec_stat_parameters
{
  int    frame_ctr           [NUM_SLICE_TYPES];          //!< Counter for different frame coding types (assumes one slice type per frame)
  int64  mode_use            [NUM_SLICE_TYPES][MAXMODE]; //!< Macroblock mode usage per slice
  int64  mode_use_transform  [NUM_SLICE_TYPES][MAXMODE][2];

  int64  *histogram_mv  [2][2];    //!< mv histogram (per list and per direction)
  int64  *histogram_refs[2];       //!< reference histogram (per list)
} DecStatParameters;

extern void init_dec_stats  (DecStatParameters *stats);
extern void delete_dec_stats(DecStatParameters *stats);


#endif
