/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/
/*!
 **************************************************************************
 *  \file errdo_dist_mhyp.h
 *  \brief  
 *    Header file for distortion estimation with multiple decoder based method
 *
 *  \author 
 *    Main contributors (see contributors.h for copyright, address and affiliation details)
 *    - Zhifeng Chen                     <zzchen@dolby.com>
 *
 **************************************************************************
 */

#ifndef _ERRDO_DIST_MHYP_H_
#define _ERRDO_DIST_MHYP_H_

extern void errdo_store_best_block_multihyp  (InputParameters *p_Inp, imgpel*** mbY, imgpel*** dec_img, int block, int img_i, int img_j, int block_size);
extern void errdo_get_best_block_multihyp    (Macroblock *currMB, imgpel*** dec_img, imgpel*** mbY, int block, int block_size);
extern distblk errdo_distortion_estimation_multihyp(Macroblock *currMB, int block, int block_size, short mode, short pdir, distblk min_rdcost);
extern void copy_conceal_picture    (VideoParameters *p_Vid, StorablePicture *enc_pic, int decoder);
#endif
