/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 ***************************************************************************
 *
 * \file fmo.h
 *
 * \brief
 *    Support for Flexible Macroblock Ordering
 *
 * \date
 *    16 June 2002
 *
 * \author
 *    Stephan Wenger   stewe@cs.tu-berlin.de
 **************************************************************************/

#ifndef _FMO_H_
#define _FMO_H_

extern int  FmoInit                       (VideoParameters * p_Vid, pic_parameter_set_rbsp_t * pps, seq_parameter_set_rbsp_t * sps);
extern void FmoUninit                     (VideoParameters *p_Vid);
extern int  FmoFinit                      (seq_parameter_set_rbsp_t * sps);
extern int  FmoMB2SliceGroup              (VideoParameters *p_Vid, int mb);
extern int  FmoGetFirstMBOfSliceGroup     (VideoParameters *p_Vid, int SliceGroupID);
extern int  FmoGetFirstMacroblockInSlice  (VideoParameters *p_Vid, int SliceGroup);
extern int  FmoGetNextMBNr                (VideoParameters *p_Vid, int CurrentMbNr);
extern int  FmoGetPreviousMBNr            (VideoParameters *p_Vid, int CurrentMbNr);
extern int  FmoGetLastCodedMBOfSliceGroup (VideoParameters *p_Vid, int SliceGroupID);
extern int  FmoStartPicture               (VideoParameters *p_Vid);
extern int  FmoEndPicture                 (void);
extern int  FmoSliceGroupCompletelyCoded  (VideoParameters *p_Vid, int SliceGroupID);
extern void FmoSetLastMacroblockInSlice   (VideoParameters *p_Vid, int mb);


#endif
