/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/
/*!
 ***************************************************************************
 *
 * \file intra16x16.h
 *
 * \brief
 *    prototypes of 16x16 intra prediction 
 *
 * \date
 *    26 September 2009
 *
 * \author
 *    Main contributors (see contributors.h for copyright, address and affiliation details)
 *    Alexis Michael Tourapis
 **************************************************************************/

#ifndef _INTRA16X16_H_
#define _INTRA16X16_H_

extern distblk distI16x16_sad  (Macroblock *currMB, imgpel **img_org, imgpel **pred_img, distblk min_cost);
extern distblk distI16x16_sse  (Macroblock *currMB, imgpel **img_org, imgpel **pred_img, distblk min_cost);
extern distblk distI16x16_satd (Macroblock *currMB, imgpel **img_org, imgpel **pred_img, distblk min_cost);

extern distblk find_sad_16x16_JM      (Macroblock *currMB);

extern void set_intrapred_16x16_mbaff (Macroblock *currMB, ColorPlane pl, int *left_available, int *up_available, int *all_available);
extern void set_intrapred_16x16       (Macroblock *currMB, ColorPlane pl, int *left_available, int *up_available, int *all_available);
extern void get_intrapred_16x16       (Macroblock *currMB, ColorPlane pl, int i16x16_mode, int left_available, int up_available);

#endif //_INTRA16X16_H_
