/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/
/*!
 ***************************************************************************
 * \file
 *    lambda.h
 *
 * \date
 *    13 September 2009
 *
 * \brief
 *    Headerfile for lagrangian lambda related computations
 * \author
 *    Main contributors (see contributors.h for copyright, address and affiliation details)
 *     - Alexis Michael Tourapis         <alexismt@ieee.org> 

 **************************************************************************
 */

#ifndef _LAMBDA_H_
#define _LAMBDA_H_

#include "global.h"

extern void get_implicit_lambda_p_slice (Slice *currSlice);
extern void get_implicit_lambda_b_slice (Slice *currSlice);
extern void get_implicit_lambda_i_slice (Slice *currSlice);
extern void get_implicit_lambda_sp_slice(Slice *currSlice);
extern void get_explicit_lambda         (Slice *currSlice);
extern void get_fixed_lambda            (Slice *currSlice);
extern void set_rdoq_lambda             (Slice *currSlice);

#endif
