/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 ************************************************************************
 * \file
 *    macroblock_p444.h
 *
 * \brief
 *    Arrays for macroblock processing (P444 mode)
 *
 * \author
 *
 ************************************************************************/

#ifndef _MACROBLOCK_P444_H_
#define _MACROBLOCK_P444_H_

#include "block.h"

extern int luma_residual_coding_p444_16x16 (Macroblock* currMB, int, short, int[2], char *);
extern int luma_residual_coding_p444_8x8   (Macroblock* currMB, int*, int64*, int, short, int[2], char *);
extern void luma_residual_coding_p444 (Macroblock *currMB);

#endif

