/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/
/*!
 ***************************************************************************
 * \file
 *    q_around.h
 *
 * \author
 *    Alexis Michael Tourapis
 *
 * \brief
 *    Headerfile for Quantization Adaptive Rounding
 **************************************************************************
 */

#ifndef _Q_AROUND_H_
#define _Q_AROUND_H_

extern void update_adaptive_rounding_8x8  (VideoParameters *p_Vid, InputParameters *p_Inp, RD_8x8DATA* dataTr, int**** ARCofAdj);
extern void store_adaptive_rounding_4x4   (VideoParameters *p_Vid, int****ARCofAdj, int mode, int block_y, int block_x);
extern void update_adaptive_rounding_4x4  (VideoParameters *p_Vid, int****ARCofAdj , int mode, int block_y, int block_x);
extern void update_adaptive_rounding_16x16(VideoParameters *p_Vid, int****ARCofAdj , int mode);
extern void store_adaptive_rounding_16x16 (VideoParameters *p_Vid, int****ARCofAdj, int mode);
extern void reset_adaptive_rounding_direct(VideoParameters *p_Vid);
extern void update_offset_params          (Macroblock *currMB, int mode, byte luma_transform_size_8x8_flag);

#endif

