/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 ***************************************************************************
 * \file
 *    q_matrix.h
 *
 * \brief
 *    Headerfile for q_matrix array
 *
 * \date
 *    07. Apr 2004
 ***************************************************************************
 */

#ifndef _Q_MATRIX_H_
#define _Q_MATRIX_H_

struct scaling_list {
  short ScalingList4x4input[6][16];
  short ScalingList8x8input[6][64];
  short ScalingList4x4[6][16];
  short ScalingList8x8[6][64];

  short UseDefaultScalingMatrix4x4Flag[6];
  short UseDefaultScalingMatrix8x8Flag[6];
};

extern void init_qmatrix (VideoParameters *p_Vid, InputParameters *p_Inp);
extern void CalculateQuant4x4Param (VideoParameters *p_Vid);
extern void CalculateQuant8x8Param (VideoParameters *p_Vid);
extern void free_QMatrix(QuantParameters *p_Quant);

#endif
