/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
************************************************************************
* \file quant4x4.h
*
* \brief
*    Quantization process header file
*
* \author
*    Limin Liu                       <lliu@dolby.com>
*    Alexis Michael Tourapis         <alexismt@ieee.org>                
*
************************************************************************
*/

#ifndef _QUANT4x4_H_
#define _QUANT4x4_H_

extern void init_quant_4x4  (Slice *currSlice);

extern int quant_4x4_normal (Macroblock *currMB, int **tblock, struct quant_methods *q_method);
extern int quant_4x4_around (Macroblock *currMB, int **tblock, struct quant_methods *q_method);
extern int quant_4x4_trellis(Macroblock *currMB, int **tblock, struct quant_methods *q_method);
extern int quant_dc4x4_normal (Macroblock *currMB, int **tblock, int qp, int* DCLevel, int* DCRun, 
                               LevelQuantParams *q_params_4x4, const byte (*pos_scan)[2]);

extern int quant_dc4x4_around (Macroblock *currMB, int **tblock, int qp, int* DCLevel, int* DCRun, 
                               LevelQuantParams *q_params_4x4, const byte (*pos_scan)[2]);

extern int quant_dc4x4_trellis(Macroblock *currMB, int **tblock, int qp, int* DCLevel, int* DCRun, 
                               LevelQuantParams *q_params_4x4, const byte (*pos_scan)[2]);

extern int quant_ac4x4_normal (Macroblock *currMB, int **tblock, struct quant_methods *q_method);
extern int quant_ac4x4_around (Macroblock *currMB, int **tblock, struct quant_methods *q_method);
extern int quant_ac4x4_trellis(Macroblock *currMB, int **tblock, struct quant_methods *q_method);

extern void rdoq_4x4_CAVLC    (Macroblock *currMB, int **tblock, struct quant_methods *q_method, int levelTrellis[16]);

extern void rdoq_4x4_CABAC    (Macroblock *currMB, int **tblock, struct quant_methods *q_method, int levelTrellis[16]);

extern void rdoq_dc_CAVLC     (Macroblock *currMB, int **tblock, int qp_per, int qp_rem, LevelQuantParams *q_params_4x4, 
                               const byte (*pos_scan)[2], int levelTrellis[16], int type);

extern void rdoq_dc_CABAC     (Macroblock *currMB, int **tblock, int qp_per, int qp_rem, LevelQuantParams *q_params_4x4, 
                               const byte (*pos_scan)[2], int levelTrellis[16], int type);

extern void rdoq_ac4x4_CAVLC  (Macroblock *currMB, int **tblock, struct quant_methods *q_method, int levelTrellis[16]);

extern void rdoq_ac4x4_CABAC  (Macroblock *currMB, int **tblock , struct quant_methods *q_method, int levelTrellis[16]);


#endif

