/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 ***************************************************************************
 * \file
 *    ratectl.h
 *
 * \author
 *    Zhengguo LI
 *    Athanasios Leontaris
 *
 * \date
 *    14 Jan 2003
 *
 * \brief
 *    Headerfile for rate control
 **************************************************************************
 */

#ifndef _RATE_CTL_H_
#define _RATE_CTL_H_

#include "global.h"
#include "rc_quadratic.h"


// generic functions
extern int    Qstep2QP          ( double Qstep, int qp_offset );
extern double QP2Qstep          ( int QP );
extern int    ComputeMBMAD      ( int diff[16][16] );
extern double ComputeFrameMAD   ( VideoParameters *p_Vid );
extern void   rc_store_mad      ( Macroblock *currMB );

// rate control functions
// init/copy
extern void  rc_alloc_generic           ( VideoParameters *p_Vid, RCGeneric **p_quad );
extern void  rc_free_generic            ( RCGeneric **p_quad );
extern void  rc_copy_generic            ( VideoParameters *p_Vid, RCGeneric *dst, RCGeneric *src );
extern void  rc_init_gop_params         ( VideoParameters *p_Vid, InputParameters *p_Inp );
extern void  rc_init_frame              ( VideoParameters *p_Vid, InputParameters *p_Inp);
extern void  rc_init_sequence           ( VideoParameters *p_Vid, InputParameters *p_Inp);
extern void  rc_store_slice_header_bits ( VideoParameters *p_Vid, InputParameters *p_Inp, int len);

#endif

