/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/
/*!
 ***************************************************************************
 * \file
 *    rd_intra_jm.h
 *
 * \author
 *    Alexis Michael Tourapis
 *
 * \date
 *    2 January 2008
 *
 * \brief
 *    Headerfile for JM rd based intra mode decision
 **************************************************************************
 */

#ifndef _RD_INTRA_JM_H_
#define _RD_INTRA_JM_H_

extern int mode_decision_for_I16x16_MB_RDO          (Macroblock *currMB, int lambda);
extern int mode_decision_for_I16x16_MB              (Macroblock *currMB, int lambda);
extern int mode_decision_for_I4x4_blocks_JM_High    (Macroblock *currMB, int  b8,  int  b4,  int  lambda,  distblk*  min_cost);
extern int mode_decision_for_I4x4_blocks_JM_Low     (Macroblock *currMB, int  b8,  int  b4,  int  lambda,  distblk*  min_cost);
extern int find_best_mode_I16x16_MB                 (Macroblock *currMB, int lambda, distblk min_cost);

#endif

