/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
*************************************************************************************
* \file  c3d_rpu_kernel_utils.h
*
* \brief 
*
*
* \author 
*    Main contributors
*        - Hariharan Ganapathy   (hari.ganapathy@dolby.com)
*
*
*************************************************************************************
*/



#ifndef _C3D_RPU_KERNEL_UTILS_H_
#define _C3D_RPU_KERNEL_UTILS_H_

/** FUNCTION MACROS */

/** Absolute value */
#define ABS_VAL(a)                  (((a) >= 0) ? (a) : -(a))

/**
 * The function macro shifts the input right by val.
 * Right shift by a negative integer is interpreted as left shift by its absolute value.
 */
#define SHIFT_RIGHT(in, shift)      ((shift) >= 0 ? ((in) >> (shift)) : ((in) << ABS_VAL(shift)))


/** The greater of two numbers */
#define MAX_VAL(a, b)               (((a) > (b)) ? (a) : (b))

/** The smaller of two numbers */
#define MIN_VAL(a, b)               (((a) < (b)) ? (a) : (b))

/* clip 16-bit signed input to 8-bit unsigned value */
#define CLIP(x)                     (MIN_VAL((MAX_VAL((x), (0))), (255)))
/*#define CLIP(x)                   u8ClipTable[(uint16_t)x] */

/* add offset and shift right */
#define OFFSET_SHIFT_RIGHT(x, o, a) (((x) +(o))>> (a))




#endif /* _C3D_RPU_KERNEL_UTILS_H_ */
